searchNodes=[{"ref":"Peluquera.html","title":"Peluquera","type":"module","doc":"The top-level supervisor process that allows to use Peluquero inside the main application supervision tree rather than as a bare application."},{"ref":"Peluquera.html#child_spec/1","title":"Peluquera.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Peluquera.html#handle_cast/2","title":"Peluquera.handle_cast/2","type":"function","doc":""},{"ref":"Peluquera.html#suicide/0","title":"Peluquera.suicide/0","type":"function","doc":""},{"ref":"Peluquero.html","title":"Peluquero","type":"module","doc":"Application handler for the Peluquero application. Peluquero is the multi-purpose, multi-protocol message handling utility. It provides the transparent way to subscribe to rabbit queues, re-shape the messages and spit out everything to other queues. It also supports transparent redis connection for those who need to store the data in redis. Basically, one would configure Peluquero through consul (explicit configuration is also allowed, though I would strongly encourage users to use consul for the configuration,) and declare so-called scissors to mutate the messages from sources before putting them into destinations. Multiple sources as well as multiple destinations are allowed. Example of the configuration that reads two different message queues, transforms data and spits it out to the “common” queue, that might be used by subscribers (join different sources): config :peluquero, :peluquerias, [ football_scores: [ scissors: [{MyModule, :my_function}], consul: &quot;configuration/football&quot;, pool: [actors: [size: 50, max_overflow: 100]]]] The configuration above would read the settings for rabbits from consul (under football key,) subscribe to the rabbit using the pool of 50 workers and call MyModule.my_function/1 on each subsequent message received from sources. As MyModule.my_function/1 returns, the value it returned will be placed into all the destination queues, specified in consul (if it returns nil, the original value will be used.) The tree structure of consul settings would be as follows: configuration/football/ destinations/ exchangeY/ routing_key ⇒ transformed exchangeZ/ rabbit/ host ⇒ localhost password ⇒ my_rabbit_password port ⇒ 5672 user ⇒ my_rabbit_user virtual_host ⇒ my_virtual_host x_message_ttl ⇒ 4000 sources/ exchangeA/ prefetch_count ⇒ 30 routing_key ⇒ to_transform exchangeB/ prefetch_count ⇒ 50 queue ⇒ queue_name routing_key ⇒ to_transform redis/ host ⇒ localhost port ⇒ 11887 database ⇒ 0 pwd ⇒ my_redis_password my_module_1.ex Peluquero.Peluqueria.scissors!(:p1, &amp;IO.puts/1) # adds another handler in runtime Peluquero.Peluqueria.scissors!(:p2, fn payload -&gt; payload |&gt; Jason.decode! |&gt; Map.put(:timestamp, DateTime.utc_now()) |&gt; Jason.encode! # if this transformer is last, it’s safe to return a term end) # adds another handler in runtime, to :p2 named instance The result of the above would be: direct exchanges exchangeA and exchangeB would be consumed with routing_key being to_transform; all the messages will be put to stdout twice (one with IO.inspect, configured in config.exs and another with IO.puts, attached in runtime); all the messages will be extended with new :timestamp field; all the messages will be published to direct exchangeY with routing_key being set to transformed and to fanout exchange exchangeZ. Handlers might be added in runtime using Peluquero.handler!/1, that accepts any type of transformers described above. Handlers are appended to the list. Maybe later this function would accept an optional parameter, saying whether the handler should be appended, or prepended. Also, Peluquero simplifies the Redis access: all the connection boilerplate is handler by Peluquero, allowing storing a Redis values based on streaming queue (e.g. “current value”) as easy as declaring one scissors delegating to Peluquero.Peinados.set/3."},{"ref":"Peluquero.Peinados.html","title":"Peluquero.Peinados","type":"module","doc":"The supervisor process for the Peluquero.Redis instances."},{"ref":"Peluquero.Peinados.html#active?/0","title":"Peluquero.Peinados.active?/0","type":"function","doc":"Returns true if Peinados has at least one child."},{"ref":"Peluquero.Peinados.html#child?/1","title":"Peluquero.Peinados.child?/1","type":"function","doc":"Checks whether the child exists"},{"ref":"Peluquero.Peinados.html#child_spec/1","title":"Peluquero.Peinados.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Peluquero.Peinados.html#children/1","title":"Peluquero.Peinados.children/1","type":"function","doc":"Retrieves the list of peinados available"},{"ref":"Peluquero.Peinados.html#del/2","title":"Peluquero.Peinados.del/2","type":"function","doc":"Deletes the value by key from the redis, specified by name"},{"ref":"Peluquero.Peinados.html#get/2","title":"Peluquero.Peinados.get/2","type":"function","doc":"Retrieves the value by key from the redis, specified by name"},{"ref":"Peluquero.Peinados.html#init/1","title":"Peluquero.Peinados.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"Peluquero.Peinados.html#set/3","title":"Peluquero.Peinados.set/3","type":"function","doc":"Sets a new value for the key in the redis, specified by name"},{"ref":"Peluquero.Peinados.html#start_link/1","title":"Peluquero.Peinados.start_link/1","type":"function","doc":""},{"ref":"Peluquero.Peluqueria.html","title":"Peluquero.Peluqueria","type":"module","doc":"The supervisor process for the Peluquero.Actor and Peluquero.Rabbit pair."},{"ref":"Peluquero.Peluqueria.html#blunt!/2","title":"Peluquero.Peluqueria.blunt!/2","type":"function","doc":"Removes the middleware from the middlewares list"},{"ref":"Peluquero.Peluqueria.html#child_spec/1","title":"Peluquero.Peluqueria.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Peluquero.Peluqueria.html#comb!/2","title":"Peluquero.Peluqueria.comb!/2","type":"function","doc":"Adds a handler to the handlers list"},{"ref":"Peluquero.Peluqueria.html#comb!/5","title":"Peluquero.Peluqueria.comb!/5","type":"function","doc":"Directly publishes a payload to the publisher specified by name, queue and exchange"},{"ref":"Peluquero.Peluqueria.html#publish!/2","title":"Peluquero.Peluqueria.publish!/2","type":"function","doc":""},{"ref":"Peluquero.Peluqueria.html#publish!/5","title":"Peluquero.Peluqueria.publish!/5","type":"function","doc":"Publishes a new message to publisher specified by name, queue and exchange"},{"ref":"Peluquero.Peluqueria.html#scissors!/2","title":"Peluquero.Peluqueria.scissors!/2","type":"function","doc":"Adds a middleware to the middlewares list"},{"ref":"Peluquero.Peluqueria.html#shear!/2","title":"Peluquero.Peluqueria.shear!/2","type":"function","doc":"Adds a handler to the handlers list"},{"ref":"Peluquero.Peluqueria.html#shear!/5","title":"Peluquero.Peluqueria.shear!/5","type":"function","doc":"Directly publishes a payload to the publisher specified by name, queue and exchange"},{"ref":"Peluquero.Peluqueria.Chairs.html","title":"Peluquero.Peluqueria.Chairs","type":"module","doc":"Internally used module to maintain a list of middlewares used to shave inputs. Peluquero.scissors!/2 calls this module to add the middleware. Peluquero.blunt!/2 can be used to remove the middleware(s)."},{"ref":"Peluquero.Peluqueria.Chairs.html#blunt!/2","title":"Peluquero.Peluqueria.Chairs.blunt!/2","type":"function","doc":"Removes the middleware from the middlewares list"},{"ref":"Peluquero.Peluqueria.Chairs.html#child_spec/1","title":"Peluquero.Peluqueria.Chairs.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Peluquero.Peluqueria.Chairs.html#scissors!/2","title":"Peluquero.Peluqueria.Chairs.scissors!/2","type":"function","doc":"Adds a middleware to the middlewares list"},{"ref":"Peluquero.Peluqueria.Chairs.html#scissors?/1","title":"Peluquero.Peluqueria.Chairs.scissors?/1","type":"function","doc":"Retrieves a list of middlewares"},{"ref":"Peluquero.Utils.html","title":"Peluquero.Utils","type":"module","doc":"Plain utilities for the project"},{"ref":"Peluquero.Utils.html#consul_key_type/1","title":"Peluquero.Utils.consul_key_type/1","type":"function","doc":"Quick check for the consul key. ## Examples iex&gt; Peluquero.Utils.consul_key_type(&quot;a/b/c/&quot;) {:nested, :bag, &quot;a&quot;} iex&gt; Peluquero.Utils.consul_key_type(&quot;a/b/c&quot;) {:nested, :item, &quot;a&quot;} iex&gt; Peluquero.Utils.consul_key_type(&quot;a/&quot;) {:plain, :bag, &quot;a&quot;} iex&gt; Peluquero.Utils.consul_key_type(&quot;a&quot;) {:plain, :item, &quot;a&quot;}"},{"ref":"Peluquero.Utils.html#safe/1","title":"Peluquero.Utils.safe/1","type":"function","doc":""},{"ref":"Peluquero.Utils.html#safe_method/4","title":"Peluquero.Utils.safe_method/4","type":"macro","doc":""},{"ref":"Peluquero.Utils.html#safe_method/5","title":"Peluquero.Utils.safe_method/5","type":"macro","doc":""},{"ref":"Peluquero.Errors.UnknownTarget.html","title":"Peluquero.Errors.UnknownTarget","type":"exception","doc":""},{"ref":"intro.html","title":"Intro","type":"extras","doc":""},{"ref":"intro.html#peluquero-in-a-nutshell","title":"Intro - Peluquero in a Nutshell","type":"extras","doc":""},{"ref":"intro.html#intro","title":"Intro - Intro","type":"extras","doc":"Peluquero sp., [peluˈkeɾo] — the hairstylist. This package got this name after what it basically does is shaving off and styling things. Peluquero is reading all the configured source exchanges, passes each payload to the chain of configured transformers and publishes the result to all the configured destination exchanges. The transformer might be either a function of arity 1, or a tuple of two atoms, specifying the module and the function of arity 1 within this module. Return value of transformed is used as a new payload, unless transformer returns either :ok or nil. If this is a case, the payload is left intact. Peluquero is able to read all the configuration values either from consul or from config. Consul takes a precedence when both are specified for the rabbit config."},{"ref":"intro.html#getting-started","title":"Intro - Getting Started","type":"extras","doc":"See Getting Started."},{"ref":"intro.html#configuration","title":"Intro - Configuration","type":"extras","doc":"Configuration (config.exs) config :peluquero, :peluquerias, local: [ scissors: [{IO, :inspect}], # functions to apply on input rabbits: 2, # amount of rabbit consumers rabbit: [ # rabbit configuration host: &quot;localhost&quot;, password: &quot;guest&quot;, port: 5672, username: &quot;guest&quot;, virtual_host: &quot;/&quot;, x_message_ttl: &quot;4000&quot; ], opts: [ # might be overwritten by consul sources: [ # source to subscribe to fanout: [ prefetch_count: 30, queue: &quot;fanout.queue1&quot; ], direct: [ prefetch_count: 30, queue: &quot;direct.queue2&quot;, routing_key: &quot;direct-routing-key&quot;, x_max_length: 10_000 ] ], destinations: [ # where to post processed messages loop: [ queue: &quot;direct.queue3&quot;, ] ] ] ], remote: [ # config will be read from consul scissors: [{MyApp.Bucket, :put}], consul: &quot;configuration/my_app/peluquero/rabbits&quot; ] ] Configuration (consul) configuration/my_app/peluquero/rabbits destinations/ exchangeY/ routing_key ⇒ transformed exchangeZ/ rabbit/ host ⇒ 10.0.0.0 user ⇒ my_rabbit_user password ⇒ my_rabbit_password port ⇒ 5672 virtual_host ⇒ my_virtual_host x_message_ttl ⇒ 4000 sources/ exchangeA/ prefetch_count ⇒ 30 routing_key ⇒ to_transform exchangeB/ prefetch_count ⇒ 50 queue ⇒ queue_name routing_key ⇒ to_transform redis/ host ⇒ localhost port ⇒ 11887 database ⇒ 0 pwd ⇒ my_redis_password Configuration example Peluquero.Peluqueria.scissors!(:p1, &amp;IO.puts/1) # adds another handler in runtime Peluquero.Peluqueria.scissors!(:p2, fn payload -&gt; payload |&gt; JSON.decode! |&gt; Map.put(:timestamp, DateTime.utc_now()) |&gt; JSON.encode! # if this transformer is last, it’s safe to return a term end) # adds another handler in runtime, to :p2 named instance The result of the above would be: direct exchanges exchangeA and exchangeB would be consumed with routing_key being to_transform; all the messages will be put to stdout twice (one with IO.inspect, configured in config.exs and another with IO.puts, attached in runtime); all the messages will be extended with new :timestamp field; all the messages will be published to direct exchangeY with routing_key being set to transformed and to fanout exchange exchangeZ. Handlers might be added in runtime using Peluquero.handler!/1, that accepts any type of transformers described above. Handlers are appended to the list. Maybe later this function would accept an optional parameter, saying whether the handler should be appended, or prepended. Also, Peluquero simplifies the Redis access: all the connection boilerplate is handler by Peluquero, allowing storing a Redis values based on streaming queue (e.g. “current value”) as easy as declaring one scissors delegating to Peluquero.Peinados.set/3. Simplified settings with explicit rabbit config key Starting with 0.4.0 we allow [though not recommend] an explicit settings of RabbitMQ parameters directly in confix.exs file. See Usage section below for details."},{"ref":"intro.html#installation","title":"Intro - Installation","type":"extras","doc":"def deps do [ ... {:peluquero, &quot;~&gt; 0.10&quot;}, ... ] end def applications do [ ... :peluquero, ... ] end"},{"ref":"intro.html#different-modes","title":"Intro - Different modes","type":"extras","doc":"The easiest way is to start the application as a dependency as shown above. The drawback, though, might be that the first messages remain unacked, if some functionality from MyApp is required (MyApp is not still loaded at this very moment.) In that case, one might add peluquero in included_applications list instead, and start it manually. The Supervisor to be put into the MyApp’s supervision tree is named Peluquera (note trailing “a”!)"},{"ref":"intro.html#usage","title":"Intro - Usage","type":"extras","doc":"Peluquero supports running for many different sources/environments (like if we were allowed to run many instances of the same application.) When multiple environments are used, they should be referred by name (see configuration.) config.exs config :peluquero, :peluquerias, [ p1: [scissors: [{IO, :inspect}], consul: &quot;configuration/rabbit1&quot;], p2: [scissors: [fn msg -&gt; msg end], rabbit: [ host: &quot;localhost&quot;, password: &quot;guest&quot;, port: 5672, username: &quot;guest&quot;, virtual_host: &quot;/&quot;, x_message_ttl: &quot;4000&quot;]] ] # optional config :peluquero, :peinados, [ # params are under &quot;configurarion/macroservices/peluquero/redis&quot; key, see above redis: [consul: &quot;configuration/macroservices/peluquero&quot;] ] For the single rabbit one might use the simplified syntax: config :peluquero, :consul, &quot;configuration/rabbit1&quot; config :peluquero, :scissors, [{IO, :inspect}]"},{"ref":"intro.html#processes","title":"Intro - Processes","type":"extras","doc":""},{"ref":"intro.html#changelog","title":"Intro - Changelog","type":"extras","doc":"0.10.0 extensive testing, code formatted by Elixir formatter, comb!/{2,4} function to publish to destination queues without shaving, shear!/{2,4} to publish to destination queues with shaving applied, publish!/{2,4} to publish to destination queues bypassing actors pool (dangerous, not recommended.) 0.7.2 More sophisticated queue name, including all nodes name’s hash. 0.7.0 Peinados were granted with diagnostics: @spec children([:full|:short|:uniq]) :: List.t @spec child?(String.t) :: bool @spec active?() :: bool Also, new configuration parameter added: safe_peinados. When true, returns nil instead of throwing an exception on calls to incorrect peinados. 0.6.0 BREAKING removed a deprecated Supervisor.Spec and dropped support for Elixir &lt; 1.5 cleanups, readmes, docs 0.5.0 transparent Redis support (no boilerplate, auto reconnects): defmodule RedisAgent do use GenServer @peinado :redis def start_link(_opts) do GenServer.start_link(fn -&gt; %{} end, name: __MODULE__) end def get(key), do: Peluquero.Peinados.get(@peinado, key) def put(key, value), do: Peluquero.Peinados.set(@peinado, key, value) end 0.4.0 allow explicit RabbitMQ settings in config (no consul needed.) Documentation can be found at https://hexdocs.pm/peluquero."},{"ref":"gettingstarted.html","title":"GettingStarted","type":"extras","doc":""},{"ref":"gettingstarted.html#getting-started","title":"GettingStarted - Getting Started","type":"extras","doc":"Why? One uses Peluquero to put the whole interoperation with RabbitMQ under the hood. It effectively establishes, keeps and watches the connections, allows very detail configuration tuning and provides the extensive flexibility and reliability while dealing with RabbitMQ. Simplest config Imagine one wants to read two different queues, &quot;fanout.queue&quot; that is bound to fanout exchange, and &quot;direct.queue&quot; bound to direct exchange. The messages read should be mixed together, coerced to the same representation, formatted and then published to another queue &quot;shaved.queue&quot; with a routing key &quot;shaved-routing-key&quot;. The config below should be self-explanatory. config :peluquero, :peluquerias, rabbit1: [ scissors: [{MyModule, :coerce}, {MyOtherModule, :format}], rabbits: 5, rabbit: [ host: &quot;localhost&quot;, password: &quot;guest&quot;, port: 5672, username: &quot;guest&quot;, virtual_host: &quot;/&quot;, x_message_ttl: &quot;4000&quot; ], opts: [ sources: [ fanout: [ prefetch_count: 30, queue: &quot;fanout.queue&quot; ], direct: [ queue: &quot;direct.queue&quot;, routing_key: &quot;direct-routing-key&quot;, x_max_length: 10_000 ] ], destinations: [ filtered: [ queue: &quot;shaved.queue&quot;, routing_key: &quot;shaved-routing-key&quot; ] ] ] ] ] The code needed to accomplish this task: none. Config is enough. Yay. Sophisticated tuning Peluquero allows to config/tune up nearly everything, through config file. Also, instead of storing the configuration in the file near the source code, one might use Consul to store configuration. See Intro for the config details. Also, Peluquero allows to add/remove scissors (functions used to “shave” the input to produce the output) on the fly. Scissors are stored as a FILO and called one by one."}]